djangoApp/lab03/encuesta/urls.py
from django.urls import path

from . import views

app_name = 'encuesta'

urlpatterns = [
    # ex: /encuesta/
    path ('', views.index, name='index'),
    # ex: /encuesta/5/
    path ('<int:pregunta_id>/', views.detalle, name='detalle'),
    # ex: /encuesta/5/resultados/
    path ('<int:pregunta_id>/resultados/', views.resultados, name='resultados'),
    # ex: /encuesta/5/voto/
    path('<int:pregunta_id>/voto/', views.votar, name='votar'),
]

djangoApp/lab03/lab03/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('encuesta/', include('encuesta.urls')),
    path('admin/', admin.site.urls),
]

djangoApp/lab03/encuesta/models.py
from django.db import models

# Create your models here.

class Pregunta (models.Model):
    pregunta_texto = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

class Opcion (models.Model):
    pregunta = models.ForeignKey(Pregunta, on_delete=models.CASCADE)
    opcion_texto = models.CharField(max_length=200)
    votos = models.IntegerField(default=0)

djangoApp/lab03/encuesta/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse

from .models import Opcion, Pregunta

def index(request):
    latest_question_list = Pregunta.objects.order_by('-pub_date')[:5]
    context = {'latest_question_list': latest_question_list}
    return render(request, 'encuesta/index.html', context)

def detalle(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    return render(request, 'encuesta/detalle.html', {'pregunta': pregunta})

def votar(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    try:
        selected_opcion = pregunta.opcion_set.get(pk=request.POST['opcion'])
    except (KeyError, Opcion.DoesNotExist):
        return render(request, 'encuesta/detalle.html', {
            'pregunta': pregunta,
            'error_message': "No has seleccionado una opcion.",
        })
    else:
        selected_opcion.votos += 1
        selected_opcion.save()
        return HttpResponseRedirect(reverse('encuesta:resultados', args=(pregunta.id,)))

def resultados(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    return render(request, 'encuesta/resultados.html', {'pregunta': pregunta})

djangoApp/lab03/encuesta/templates/encuesta/detalle.html
<h1> {{ pregunta.pregunta_texto }} </h1>

<ul>
{% for opcion in pregunta.opcion_set.all %}
    <li>{{ opcion.opcion_texto }} -- {{ opcion.votos }} voto{{ opcion.votos|pluralize }}</li>
{% endfor %}
</ul>

<a href="{% url 'encuesta:resultados' pregunta.id %}">Votar de nuevo?</a><br>
<a href="{% url 'encuesta:index' %}">Ver preguntas</a>

djangoApp/lab03/encuesta/templates/encuesta/index.html
<h1>Encuesta</h1>

{% if latest_question_list %}
    <ul>
    {% for pregunta in latest_question_list %}
        <li>
            <a href="/encuesta/{{ pregunta.id }}/"> {{ pregunta.pregunta_texto }} </a>
        </li>
    {% endfor %}
    </ul>
{% else %}
        <p>No hay registros.</p>
{% endif %}

djangoApp/lab03/encuesta/templates/encuesta/resultados.html
<h1>{{ pregunta.pregunta_texto }}</h1>

{% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}

<form action="{% url 'encuesta:votar' pregunta.id %}" method="post">
{% csrf_token %}
    {% for opcion in pregunta.opcion_set.all %}
        <input type="radio" name="opcion" id="opcion{{ forloop.counter }}" value="{{ opcion.id }}">
        <label for="opcion{{ forloop.counter }}"> {{ opcion.opcion_texto }} </label><br>
    {% endfor %}
<input type="submit" value="Votar">
</form>
<br/>
<a href="{% url 'encuesta:index' %}">Ver preguntas</a>